function out = Equal_withExtremaControlled(img, extrema)
 %INPUT:
%       - img to transform
%       - extrema: lower and upepr extrema of the transformed image
%OUTPUT:
%       - out: the transformed image

m_IN = min(img(:));
M_IN = max(img(:));

m_OUT = extrema(1);
M_OUT = extrema(2);

%CDF
im_hist = imhist(img);
CDF = cumsum(im_hist); %transformation function
CDF = CDF / max(CDF);

x = 0:255;
LUT = (M_OUT - m_OUT)* ((CDF(x+1) - CDF(m_IN+1))/(CDF(M_IN+1) - CDF(m_IN+1))) + m_OUT;

out = uint8(LUT(img+1));

subplot(3,2,1);
imshow(img);
title('Gray Level Image');

subplot(3,2,2);
plot(im_hist);
axis tight;
title('Histogram of the Original Img');
xlabel('l.d.g.');
ylabel('#pixels');
 
img_EQUAL = histeq(img);
 
subplot(3,2,3)
imshow(img_EQUAL);
title('Equalization');

subplot(3,2,4);
imhist(img_EQUAL);
axis tight;
title('istogramma EQUAL');

subplot(3,2,5)
imshow(out, [])
title('Trasformed img by EQUALIZATION with Extrema Controlled');

subplot(3,2,6)
imhist(out);
axis tight;
title('Histogram after the Trasformation');
xlabel('l.d.g.');
ylabel('#pixels');
end
