% Inizializzazione
clc;
clear all;
close all;
 

[imgName, path] = uigetfile('*.jpg;*.bmp;*.png;*.tif;*.jpeg', 'Pick an image file');
img = imread([path imgName]);

procType = input(' 1: Inspection;\n 2: piecewiseLinear Transform;\n 3: Sigmoidal Transform;\n 4: Extrema control in the equalization;\n 5: Hist Matching on Luminance;\n 6: Hist Matching on Colors using the Lum CDF; \n 7: Hist Matching on Colors using the Color CDF .\n Choose one type of processing: ');

dim = size(size(img));
if dim(2) == 3
    img_gray = rgb2gray(img);
else
    img_gray = img;
end

switch procType
    case 1 
        tol = 0.05;
        n = input('Insert the number of gamma correctionyou want to inspect: ');
        InspectImadjust(img_gray, tol, n)
    case 2
        CP = input('Insert the control points [r1,s1,r2,s2]: '); 
        img_T = piecewiseLinearT(img_gray, CP);
    case 3
        a = input('Insert the exponent of the sigmoidal transform: ');
        imgT = sigmoidalT(img_gray, a);
    case 4
        extrema = input('Insert the extrema of the transformed image: ');
        imgT =Equal_withExtremaControlled(img_gray, extrema);
    case 5
        [imgName2, path2] = uigetfile('*.jpg;*.bmp;*.png;*.tiff;*.jpeg; *.tif', 'Pick an image file (TARGET)');
        img_T = imread([path2 imgName2]);
         
        dim = size(size(img_T));
        if dim(2) == 3
            img_grayT = rgb2gray(img_T);
        else
            img_grayT = img_T;
        end
        imgT =histogramMatching(img_gray, img_grayT);
    case 6
        [imgName2, path2] = uigetfile('*.jpg;*.bmp;*.png;*.tiff;*.jpeg; *.tif', 'Pick a color image file (TARGET)');
        img_T = imread([path2 imgName2]);
        imgT =colorHistogramMatching(img, img_T);
    case 7
        [imgName2, path2] = uigetfile('*.jpg;*.bmp;*.png;*.tiff;*.jpeg; *.tif', 'Pick a color image file (TARGET)');
        img_T = imread([path2 imgName2]);
        imgT =colorHistogramMatching2(img, img_T);
end
