function remapped = histogramMatching(Input, Target)

%Histograms
hist_I =imhist(Input);
hist_T =imhist(Target);
  
f1 = figure;
plot(hist_I);
hold on
plot(hist_T);
legend('Histogram image Input', 'Histogram Image Target');
 
%CDF
CDF_I = cumsum(hist_I); %transformation function
CDF_I = CDF_I / max(CDF_I);

CDF_T = cumsum(hist_T); %transformation function
CDF_T = CDF_T / max(CDF_T);
 
f2 = figure;
plot(CDF_I);
hold on;
plot(CDF_T);
legend('CDF Input', 'CDF Target');

%build LUT
LUT = zeros(256,1);
g_T = 0;
for g_I=0:255
    while CDF_T(g_T+1)< CDF_I(g_I+1) & g_T < 255 
        g_T = g_T + 1;
    end
LUT(g_I+1) = g_T;
end

%Histogram Matching
remapped = zeros(size(Input));
remapped = LUT(Input+1);

%Visualizations
remapped = uint8(remapped);
hist_R =imhist(remapped);
figure(f1);
hold on 
plot(hist_R);
legend('Histogram image Input', 'Histogram Image Target','Histogram of the remapped input image');


CDF_R = cumsum(hist_R); %transformation function
CDF_R = CDF_R / max(CDF_R);

figure(f2);
hold on
plot(CDF_R);
legend('CDF Input', 'CDF Target', 'CDF of the remapped input image')

figure;
subplot(1,3,1);
imshow(Input);
title('Input image');


subplot(1,3,2);
imshow(Target);
title('Target Image');

subplot(1,3,3); 
imshow(uint8(remapped));
title('Remapped Image');

