function out = piecewiseLinearT(img, CP)
%img_PWLT = piecewiseLinearT(img_gray, CP);
%INPUT:
%       - img to transform
%       - CP: cpntrol points: (CP(1),CP(2)) first control point
%       - (CP(3),CP(4)) second control point
%OUTPUT:
%       - out: the transformed image

minI = min(img(:));
maxI = max(img(:));

img1= img<CP(1);
img2= img>=CP(1) & img <CP(3);
img3= img>=CP(3);

out=zeros(size(img,1), size(img,2));

out(img1)= (CP(2)/(CP(1)-minI))*(img(img1)-minI);
out(img2)= ((CP(4)-CP(2))/(CP(3)-CP(1)))*(img(img2)-CP(1))+CP(2);
out(img3)= ((255-CP(4))/(maxI -CP(3))) * (img(img3)-CP(3)) + CP(4);
out = uint8(out); 

subplot(2,2,1);
imshow(img);
title('Immagine a Livelli di grigio');

subplot(2,2,2);
imhist(img);
title('istogramma ORIG');
xlabel('l.d.g.');
ylabel('#pixels');
 
subplot(2,2,3)
imshow(out, [])
title('img trasformata con PWLT');

subplot(2,2,4)
imhist(out);
title('istogramma dopo PWLT');
xlabel('l.d.g.');
ylabel('#pixels');
end
